StyleSheet.BoxPainter (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing.text.html, class: StyleSheet, class: BoxPainter
Keywords: javax.swing.text.html.StyleSheet.BoxPainter class

# Class StyleSheet.BoxPainter

java.lang.Object
javax.swing.text.html.StyleSheet.BoxPainter

All Implemented Interfaces:
  `Serializable`

Enclosing class:
  `StyleSheet`

public static final class StyleSheet.BoxPainter extends Object implements Serializable
Class to carry out some of the duties of CSS formatting. Implementations of this class enable views to present the CSS formatting while not knowing anything about how the CSS values are being cached.

As a delegate of Views, this object is responsible for the insets of a View and making sure the background is maintained according to the CSS attributes.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `float`
  `getInset(int side, View v)`
  Fetches the inset needed on a given side to account for the margin, border, and padding.
  `void`
  `paint(Graphics g, float x, float y, float w, float h, View v)`
  Paints the CSS box according to the attributes given.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Method Details

  - ### getInset

    public float getInset(int side, View v)
    Fetches the inset needed on a given side to account for the margin, border, and padding.
    Parameters:
      `side` - The size of the box to fetch the inset for. This can be View.TOP, View.LEFT, View.BOTTOM, or View.RIGHT.
      `v` - the view making the request. This is used to get the AttributeSet, and may be used to resolve percentage arguments.
    Returns:
      the inset needed for the margin, border and padding.
    Throws:
      `IllegalArgumentException` - for an invalid direction

  - ### paint

    public void paint(Graphics g, float x, float y, float w, float h, View v)
    Paints the CSS box according to the attributes given. This should paint the border, padding, and background.
    Parameters:
      `g` - the rendering surface.
      `x` - the x coordinate of the allocated area to render into.
      `y` - the y coordinate of the allocated area to render into.
      `w` - the width of the allocated area to render into.
      `h` - the height of the allocated area to render into.
      `v` - the view making the request. This is used to get the AttributeSet, and may be used to resolve percentage arguments.